jaciv_app/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from django.views.generic import RedirectView

from jaciv_app import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('publications/', include('publications.urls')),
    path('admin-module/', include('admin_module.urls')),
    path('', include('users.urls')),
    path('', RedirectView.as_view(url='/welcome/')),
]

urlpatterns = urlpatterns + \
    static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns = urlpatterns + \
    static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

users/urls.py
from django.urls import include, path

from users.views import Signup, account_management, update_account_details, transaction_history
from users.views import welcome, search_store, view_profile, comment_profile, rate_profile
from users.views import report_profile, suggest_profile, account_suggestions, delete_suggestion
from users.views import report_comment, delete_account, filter_search, refund_transaction

urlpatterns = [
    path(
        '',
        welcome,
        name='welcome',
    ),
    path(
        'signup/',
        Signup.as_view(),
        name='signup',
    ),
    path(
        'account-management/<int:pk>/',
        account_management,
        name='account-management',
    ),
    path(
        'update-account-details/',
        update_account_details,
        name='update-account-details',
    ),
    path(
        'transactions-history/',
        transaction_history,
        name='transactions-history',
    ),
    path(
        'search-site/',
        search_store,
        name='search-site',
    ),
    path(
        'user-account/<int:pk>',
        view_profile,
        name='user-account',
    ),
    path(
        'comment-profile/<int:profile_pk>/',
        comment_profile,
        name='comment-profile',
    ),
    path(
        'filter-publications/',
        filter_search,
        name='filter-publications',
    ),
    path(
        'rate-profile/',
        rate_profile,
        name='rate-profile',
    ),
    path(
        'report-profile/<int:profile_pk>/',
        report_profile,
        name='report-profile',
    ),
    path(
        'suggest-profile/<int:profile_pk>/',
        suggest_profile,
        name='suggest-profile',
    ),
    path(
        'user-suggestions/',
        account_suggestions,
        name='user-suggestions',
    ),
    path(
        'delete-suggestion/<uuid:pk>',
        delete_suggestion,
        name='delete-suggestion',
    ),
    path(
        'report-comment/<uuid:pk>',
        report_comment,
        name='report-comment',
    ),
    path(
        'delete-account/',
        delete_account,
        name='delete-account',
    ),
    path(
        'refund-transaction/<uuid:pk>',
        refund_transaction,
        name='refund-transaction',
    ),
]

users/models.py
import uuid
import datetime
from django.contrib.auth.models import AbstractUser
from django.db import models
from django.urls import reverse


class CustomUser(AbstractUser):
    SEX_CHOICE = (
        ('M', 'Masculino'),
        ('F', 'Femenino'),
        ('O', 'Otro'),
    )
    profile_picture = models.ImageField(
        upload_to='images/profile_pics',
        blank=True,
        null=True,
        verbose_name='foto de Perfil',
    )
    mobile_phone = models.CharField(
        max_length=13,
        verbose_name='teléfono',
    )
    sex = models.CharField(
        max_length=1,
        choices=SEX_CHOICE,
        default='O',
        verbose_name='sexo',
    )
    birth_date = models.DateField(
        verbose_name='fecha de Nacimeinto',
    )
    available_publications = models.IntegerField(
        default=0,
        verbose_name='publicaciones Disponibles',
    )
    terms_accepted = models.BooleanField(
        default=False,
        verbose_name='términos y Condiciones Aceptados',
    )

    class Meta:
        indexes = [
            models.Index(fields=['id', ], name='user_id_index'),
            models.Index(fields=['username', ], name='user_username_index'),
            models.Index(fields=['email', ], name='user_email_index'),
        ]
        unique_together = (('username', 'email'),)
        ordering = ['date_joined', ]
        verbose_name = 'usuario'
        verbose_name_plural = 'usuarios'

    def __str__(self):
        return self.email

    def get_absolute_url(self):
        return reverse('user-account', args=[str(self.id)])


class Report(models.Model):
    CATEGORY = (
        ('U', 'Usuario'),
        ('C', 'Comments'),
        ('P', 'Publicación'),
    )

    id = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
    )
    sender = models.ForeignKey(
        CustomUser,
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
        related_name='customuser_as_report_sender',
        verbose_name='remitente',
    )
    recipient = models.ForeignKey(
        CustomUser,
        on_delete=models.CASCADE,
        related_name='customuser_as_report_recipient',
        verbose_name='destinatario',
    )
    slug = models.CharField(
        max_length=250,
        verbose_name='asunto',
    )
    message = models.TextField(
        max_length=750,
        verbose_name='mensaje',
    )
    category = models.CharField(
        max_length=1,
        choices=CATEGORY,
        default='U',
        verbose_name='categoría',
    )
    emission_date = models.DateTimeField(
        default=datetime.datetime.now,
        verbose_name='fecha de Emisión',
    )

    class Meta:
        indexes = [
            models.Index(fields=['id', ], name='report_id_index'),
        ]
        ordering = ['emission_date', 'recipient', ]
        verbose_name = 'reporte'
        verbose_name_plural = 'reportes'

    def __str__(self):
        return self.slug

    def get_absolute_url(self):
        return reverse('report-details', args=[str(self.id)])


class Suggestion(models.Model):
    id = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
    )
    sender = models.ForeignKey(
        CustomUser,
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
        related_name='customuser_as_suggestion_sender',
        verbose_name='remitente',
    )
    recipient = models.ForeignKey(
        CustomUser,
        on_delete=models.CASCADE,
        related_name='customuser_as_suggestion_recipient',
        verbose_name='destinatario',
    )
    slug = models.CharField(
        max_length=250,
        verbose_name='asunto',
    )
    message = models.TextField(
        max_length=750,
        verbose_name='mensaje',
    )
    emission_date = models.DateTimeField(
        default=datetime.datetime.now,
        verbose_name='fecha de Emisión',
    )

    class Meta:
        indexes = [
            models.Index(fields=['id', ], name='suggestion_id_index'),
        ]
        ordering = ['emission_date', 'recipient', ]
        verbose_name = 'sugerencia'
        verbose_name_plural = 'sugerencias'

    def __str__(self):
        return self.slug

    def get_absolute_url(self):
        return reverse('suggestion-details', args=[str(self.id)])

    def get_delete_url(self):
        return reverse('delete-suggestion', args=[str(self.id)])


class Comment(models.Model):
    id = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
    )
    sender = models.ForeignKey(
        CustomUser,
        on_delete=models.CASCADE,
        related_name='customuser_as_comment_sender',
        verbose_name='remitente',
    )
    recipient = models.ForeignKey(
        CustomUser,
        on_delete=models.CASCADE,
        related_name='customuser_as_comment_recipient',
        verbose_name='destinatario',
    )
    message = models.TextField(
        max_length=250,
        verbose_name='mensaje',
    )
    emission_date = models.DateTimeField(
        default=datetime.datetime.now,
        verbose_name='fecha de Emisión',
    )

    class Meta:
        indexes = [
            models.Index(fields=['id', ], name='comment_id_index'),
        ]
        ordering = ['emission_date', 'recipient', ]
        verbose_name = 'comentario'
        verbose_name_plural = 'comentarios'

    def __str__(self):
        return self.message

    def get_absolute_url(self):
        return reverse('comment', args=[str(self.id)])

    def get_report_comment_url(self):
        return reverse('report-commnet', args=[str(self.id)])


class Raiting(models.Model):
    id = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
    )
    grader = models.ForeignKey(
        CustomUser,
        on_delete=models.CASCADE,
        related_name='customuser_as_grader',
        verbose_name='remitente',
    )
    reciever = models.ForeignKey(
        CustomUser,
        on_delete=models.CASCADE,
        related_name='customuser_as_reciever',
        verbose_name='destinatario',
    )
    grade = models.IntegerField(
        verbose_name='raiting',
    )
    grade_date = models.DateTimeField(
        default=datetime.datetime.now,
        verbose_name='fecha de Evaluación',
    )

    class Meta:
        indexes = (
            models.Index(fields=['id', ], name='raiting_id_index'),
        )
        ordering = ['reciever', 'grade_date', ]
        verbose_name = 'califiacion'
        verbose_name_plural = 'calificaciones'

    def __str__(self):
        return str(self.grade)


class Transaction(models.Model):
    id = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
    )
    publication_number = models.IntegerField(
        verbose_name='número de Publicaciones',
    ) 
    total_price = models.DecimalField(
        max_digits=9,
        decimal_places=2,
        default=0.00,
        verbose_name='precio Total',
    )
    buyer = models.ForeignKey(
        CustomUser,
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
        unique=False,
        verbose_name='comprador',
    )
    transaction_date_time = models.DateTimeField(
        default=datetime.datetime.now,
        verbose_name='fecha de Transacción',
    )
    paypal_id = models.CharField(
        max_length=64,
        verbose_name='pago Paypal ID'
    )
    payer_id = models.CharField(
        max_length=128,
        blank=True,
        verbose_name='cliente Paypal ID'
    )
    payment_status = models.BooleanField(
        default=False,
        verbose_name='estado de Pago'
    )

    class Meta:
        indexes = [
            models.Index(fields=['id', ], name='transaction_id_index'),
            models.Index(fields=['paypal_id', ], name='paypal_payment_id_index'),
            models.Index(fields=['payer_id', ], name='paypal_payer_id_index')
        ]
        ordering = ['transaction_date_time', ]
        verbose_name = 'transacción'
        verbose_name_plural = 'transacciones'

    def __str__(self):
        return f'NoP: {self.publication_number} for ${self.total_price} on {self.transaction_date_time}'

users/forms.py
import re

from django import forms
from django.contrib.auth.forms import UserCreationForm, UserChangeForm
from django.utils.translation import ugettext_lazy as _
from django.utils.safestring import mark_safe
from django.core.exceptions import ValidationError

from string import Template

from users.models import CustomUser, Report, Comment, Suggestion, Transaction, Raiting
from users.utils import check_mobile_phone_integrity, check_email_integrity


class DateInput(forms.DateInput):
    input_type = 'date'


class CustomUserCreationForm(UserCreationForm):
    class Meta (UserCreationForm):
        model = CustomUser
        fields = ['username', 'first_name', 'last_name', 'email', 'mobile_phone',
                  'birth_date', 'sex', 'terms_accepted', ]
        widgets = {
            'birth_date': DateInput(),
        }
        help_texts = {
            'email': _('email@example.com'),
            'mobile_phone': _('Por ejemplo: 5548136925'),
        }

    def __init__(self, *args, **kwargs):
        super(CustomUserCreationForm, self).__init__(*args, **kwargs)
        self.fields['first_name'].required = True
        self.fields['last_name'].required = True
        self.fields['email'].required = True
        self.fields['terms_accepted'].required = True

    def clean_mobile_phone(self):
        data = self.cleaned_data['mobile_phone']
        mobile_phone = check_mobile_phone_integrity(data)

        if mobile_phone is False:
            raise ValidationError(
                _('Número invalido: Utilice 0445512345678 (13 dígitos) ó 5512345678 (10 dígitos)'))

        return data

    def clean_email(self):
        data = self.cleaned_data['email']
        emails = CustomUser.objects.filter(email=data)
        if len(emails) > 0:
            raise ValidationError(
                _('El correo ingresado ya está en uso, intente con otro correo.')
            )

        return data


class CustomUserChangeForm(UserChangeForm):
    class Meta:
        model = CustomUser
        fields = ['email', 'profile_picture', 'mobile_phone', ]

    def clean_mobile_phone(self):
        data = self.cleaned_data['mobile_phone']
        mobile_phone = check_mobile_phone_integrity(data)

        if mobile_phone is False:
            raise ValidationError(
                _('Número invalido: Utilice 0445512345678 (13 dígitos) ó 5512345678 (10 dígitos)'))

        return data


class AccountDetailsForm(forms.ModelForm):
    class Meta:
        model = CustomUser
        fields = ['email', 'profile_picture', 'mobile_phone', ]

    def __init__(self, *args, **kwargs):
        self.user = kwargs.pop('user', None)
        super(AccountDetailsForm, self).__init__(*args, **kwargs)

    def clean_mobile_phone(self):
        data = self.cleaned_data['mobile_phone']
        mobile_phone = check_mobile_phone_integrity(data)

        if mobile_phone is False:
            raise ValidationError(
                _('Número invalido: Utilice 0445512345678 (13 dígitos) ó 5512345678 (10 dígitos)'))

        return data

    def clean_email(self):
        data = self.cleaned_data['email']
        data = data.strip()

        if self.user and self.user.email == data:
            return data
        else:
            valid_email = check_email_integrity(data)
            if not valid_email:
                raise ValidationError(
                    _('El correo ingresado es inválido o ya está en uso'))

        return data


class ReportCreationForm(forms.ModelForm):
    class Meta:
        model = Report
        fields = ['sender', 'recipient', 'slug', 'message', 'category', ]

    def __init__(self, *args, **kwargs):
        super(ReportCreationForm, self).__init__(*args, **kwargs)
        self.fields['sender'].widget = forms.HiddenInput()
        self.fields['recipient'].widget = forms.HiddenInput()
        self.fields['category'].widget = forms.HiddenInput()


class SuggestionCreationForm(forms.ModelForm):
    class Meta:
        model = Suggestion
        fields = ['sender', 'recipient', 'slug', 'message', ]

    def __init__(self, *args, **kwargs):
        super(SuggestionCreationForm, self).__init__(*args, **kwargs)
        self.fields['sender'].widget = forms.HiddenInput()
        self.fields['recipient'].widget = forms.HiddenInput()


class CommentCreationForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ['sender', 'recipient', 'message', ]

    def __init__(self, *args, **kwargs):
        super(CommentCreationForm, self).__init__(*args, **kwargs)
        self.fields['sender'].widget = forms.HiddenInput()
        self.fields['recipient'].widget = forms.HiddenInput()
        self.fields['message'].label = False


class RaitingCreationForm(forms.ModelForm):
    class Meta:
        model = Raiting
        fields = ('grader', 'reciever', 'grade')

        widgets = {
            'grade': forms.NumberInput(attrs={'id': 'gradePicker', 'readonly': True, })
        }

    def __init__(self, *args, **kwargs):
        super(RaitingCreationForm, self).__init__(*args, **kwargs)
        self.fields['grader'].widget = forms.HiddenInput()
        self.fields['reciever'].widget = forms.HiddenInput()
        self.fields['grade'].label = False

    def clean_grade(self):
        data = self.cleaned_data['grade']

        if data < 0:
            raise ValidationError(
                _('El número ingresado no puede ser menor a 0'))

        if data > 10:
            raise ValidationError(
                _('El número ingresado no puede ser mayor a 10'))

        return data


class TransactionCreationForm(forms.Form):
    class Meta:
        model = Transaction
        fields = ('publication_number', 'total_price', 'buyer')

users/templates/users/account_management.html
{% extends 'core.html' %} 

{% block title %}Mi Cuenta{% endblock %} 

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %} 
{% endblock %} 

{% block content %}
<div class="card container mt-5 mb-5">
  {% if error_message %}
      <div class="alert alert-warning alert-dismissible fade show mt-2" role="alert">
      <strong>Error: </strong>{{error_message}}
      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
          <span aria-hidden="true">&times;</span>
      </button>
      </div>    
  {% endif %}
  <div class="container mt-5 mb-2">
      <div class="row">
          <div class="col-12 col-sm-12 col-md-4 col-lg-2 col-xl-2">
            {% if user.profile_picture%}
            <img class="img-thumbnail" style="max-height:200px" src="{{user.profile_picture.url}}">
            {% else %}
            <img class="img-thumbnail" style="max-height:200px" src="{% static 'users/img/profile-placeholder.gif' %}">
            {% endif %}
          </div>
          <div class="col-12 col-sm-12 col-md-10 col-lg-10 col-xl-10">
            <div class="row">
              <div class="col-12">
                <h1 class="display-4">{{ user.first_name }} {{ user.last_name }}</h1>
              </div>
              <div class="col-12">
                <h1 class="display-6">{{ user.username }}</h1>
              </div> 
              <div class="col-12 col-sm-6 col-md-8 col-lg-10 col-xl-10">
                <p class="lead">Miembro desde: {{ user.date_joined.date }}</p>
              </div>   
              <div class="col-12 col-sm-6 col-md-4 col-lg-2 col-xl-2">
                <button id="showDetailsButton" type="button" class="btn btn-warning">Editar Cuenta</button>
              </div>             
            </div>
          </div>
      </div>
  </div>

  <div class="container"><hr/></div>

  <div class="container p-4" id="detailsContainer" style="display:none">
      <div class="card text-center align-middle">
        <div class="card-header bg-dark text-white">
            Editar Cuenta
        </div>
        <div class="card-body">
          <form method="POST" action="{% url 'update-account-details'%}" enctype="multipart/form-data">
              {% csrf_token %}
              <div class="row">
                  <div class="col-6">
                      {{ form.email|as_crispy_field }}
                  </div>
                  <div class="col-6">
                      {{ form.mobile_phone|as_crispy_field }}
                  </div>
                  <div class="col-12">
                      {{ form.profile_picture|as_crispy_field }}
                  </div>
              </div>
              <button type="submit" class="btn btn-dark">Actualizar</button>
          </form>  
          <button class="btn btn-danger mt-2" id="closeDetailsButton">Cancelar</button>    
        </div>
      </div>
      <div class="container p-4"><hr/></div>
  </div>

  <div class="container mt-2">
    <h1 class="display-5">Información Personal</h1>
    <div class="row">
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="lead"><strong>Correo:</strong> {{ user.email }}</P>
        </div>
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="lead"><strong>Teléfono:</strong> {{ user.mobile_phone }}</P>
        </div>    
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="lead"><strong>Sexo:</strong> {{ user.get_sex_display }}</P>
        </div>
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="lead"><strong>Fecha de Nacimiento:</strong> {{ user.birth_date }}</P>
        </div>          
    </div>
  </div>

  <div class="container"><hr/></div>

  <div class="container mt-2">
    <h1 class="display-5">Detalles de la Cuenta</h1>
    <div class="row">
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="lead"><strong>Publicaciones Disponibles:</strong> {{ user.available_publications }}</P>
        </div>
        {% if user.is_authenticated and not user.is_staff %}
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6 text-right">
          <a type="button" class="btn btn-danger" href="{% url 'delete-account' %}">Eliminar Cuenta</a>
        </div>
        {% endif %}
    </div>
  </div>

  <div class="container"><hr/></div>

  <div class="container mt-2">
      <h1 class="display-5">Comentarios</h1>
      <div class="row ml-3">
          {% if comments %}
          {% for comment in comments %}
          <div class="container">
              <div class="media">
                  {% if comment.sender.profile_picture %}
                  <img class="mr-3 rounded-circle img-responsive" style="min-width:75px;min-height:75px;max-height:75px;max-width:75px;" src="{{comment.sender.profile_picture.url}}" style="max-width:4em;">
                  {% else %}
                  <img class="mr-3 rounded-circle" style="min-width:75px;min-height:75px;max-height:75px;max-width:75px;" src="{% static 'users/img/profile-placeholder.gif' %}" style="max-width:4em;">
                  {% endif %}
                  <div class="media-body">
                      <h4 class="mt-0"><a class="text-dark" href="{{comment.sender.get_absolute_url}}">{{comment.sender.username}}</a></h4>
                      <div class="row">   
                            <div class="col-12">
                                <p class="lead" style="overflow-wrap: anywhere;">{{comment.message}}</p>
                            </div>
                        </div>
                      <p>{{comment.emission_date}} <em><a class="text-danger" href="{% url 'report-comment' pk=comment.id%}"> Reportar Comentario</a></em></p>
                  </div>   
              </div>
              <hr/>
          </div>
          {% endfor %}
          {% else %}
          <div class="card-body text-center">
              <p class="lead">Tu perfil no tiene ningún comentario !</p>
          </div>
          {% endif %}
      </div>
  </div>
</div>


{% endblock %}

{% block scriptfiles %}
<script src="{% static 'users/js/updateaccountdetails.js' %}"></script>
{% endblock %}

users/templates/users/account_suggestions.html
{% extends 'core.html' %} 

{% block title %}Mis Sugerencias{% endblock %} 

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %} 
{% endblock %} 

{% block content %}
<div class="container">
  <h3 class="display-5 mt-5 mb-3">Mis Sugerencias
    {% if total_suggestion == 1 %}
    <small class="text-muted">tienes {{total_suggestion}} sugerencia</small>
    {% else %}
    <small class="text-muted">tienes {{total_suggestion}} sugerencias</small>
    {% endif %}</h3>
    {% if suggestions %}
      {% for suggestion in suggestions %}
      <div class="card p-4 mb-3">
        <div class="row">
          <div class="col-10">
            <h6 class="dispaly-6"><strong>De: </strong>{{suggestion.sender.username}}</h6>
          </div>
          <div class="col-2">
            <div class="float-right"><a href="{{suggestion.get_delete_url}}">
              <span style="font-size: 1.5em; color: #dc3545;">
                <i class="far fa-trash-alt" aria-hidden="true"></i>
              </span></a>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-12">
            <p><em> el {{suggestion.emission_date.date}}</em></p>
          </div>
        </div>
        <div class="row">
          <div class="col-12">
            <h6 class="dispaly-6"><strong>Asunto: </strong>{{suggestion.slug}}</h6>
          </div>
        </div>
        <hr/>
        <div class="row">
          <div class="col-12">
            <p>{{ suggestion.message }}</p> 
          </div>
        </div>
      </div>
      {% endfor %}
    {% else %}
    <div class="container">
      <div class="card" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
        <div class="card-body">
            <p class="lead">De momento no existe ninguna sugerencia, revise más tarde !</p>
        </div>
      </div>
    </div>
    {% endif %}
  </h3>
</div>
{% endblock %}

{% block scriptfiles %}
{% endblock %}

users/templates/users/accounts_search.html
{% extends 'core.html' %}

{% block title %}Perfiles{% endblock %}

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %}
{% endblock %}

{% block content %}
{% if accounts %}
{% for account in accounts %}
<div class="container mt-5">
    <div class="row">
        <div class="col-12 col-sm-12 col-md-2 col-lg-2 col-xl-2">
            {% if account.profile_picture%}
            <img class="img-thumbnail" style="max-height:200px" src="{{account.profile_picture.url}}" />
            {% else %}
            <img class="img-thumbnail" style="max-height:200px" src="{% static 'users/img/profile-placeholder.gif' %}">
            {% endif %}
        </div>
        <div class="col-12 col-sm-12 col-md-10 col-lg-10 col-xl-10">
            <div class="row">
                <div class="col-12">
                    <h4><a class="btn btn-lg btn-outline-warning"
                            href="{{account.get_absolute_url}}">{{ account.first_name }} {{ account.last_name }} <small
                                class="text-muted">{{ account.username }}</small></a></h4>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <h6><em>Miembro desde: {{ account.date_joined.date }}</em></h6>
                </div>
            </div>
        </div>
    </div>
    <hr />
</div>
{% endfor %}
{% if accounts.has_other_pages %}
<ul class="pagination">
    {% if accounts.has_previous %}
    <li><a href="?page={{ accounts.previous_page_number }}">&laquo;</a></li>
    {% else %}
    <li class="disabled"><span>&laquo;</span></li>
    {% endif %}
    {% for i in accounts.paginator.page_range %}
    {% if accounts.number == i %}
    <li class="active"><span>{{ i }} <span class="sr-only">(current)</span></span></li>
    {% else %}
    <li><a href="?page={{ i }}">{{ i }}</a></li>
    {% endif %}
    {% endfor %}
    {% if accounts.has_next %}
    <li><a href="?page={{ accounts.next_page_number }}">&raquo;</a></li>
    {% else %}
    <li class="disabled"><span>&raquo;</span></li>
    {% endif %}
</ul>
{% endif %}
{% else %}
<div class="container">
    <div class="card" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
        <div class="card-body">
            <p class="lead">No se han encontrado perfiles con los parámetros ingresados. Vuelve a intentarlo con unos
                distintos!</p>
        </div>
    </div>
</div>
{% endif %}

{% endblock %}

{% block scriptfiles %}

{% endblock %}